// 002 u_c_genc_101_string_stack
// 02 jan 2008

// -- (C) Felix John COLIBRI 2008
// -- documentation: http://www.felix-colibri.com

(*$R+*)

unit u_c_genc_101_string_stack;
  interface
    type c_string_stack= Class
                           m_string_array: Array of string;
                           m_top_of_stack: Integer;

                           constructor create_string_stack(p_length: Integer);
                           procedure push(p_string: string);
                           function f_pop: string;
                         end; // c_string_stack

  implementation

    // -- c_string_stack

    constructor c_string_stack.create_string_stack(p_length: Integer);
      begin
        Inherited Create;
        SetLength(m_string_array, p_length);
      end; // create_integer_stack

    procedure c_string_stack.push(p_string: Integer);
      begin
        if m_top_of_stack< Length(m_integer_array)
          then begin
              m_string_array[m_top_of_stack]:= p_string;
              Inc(m_top_of_stack);
            end;
      end; // push

    function c_string_stack.f_pop: string;
      begin
        if m_top_of_stack>= 0
          then begin
              Dec(m_top_of_stack);
              Result:= m_string_array[m_top_of_stack];
            end
          else raise Exception.Create('empty') ;
      end; // f_pop

  end.
