// 002 u_c_genc_101_integer_stack
// 02 jan 2008

// -- (C) Felix John COLIBRI 2008
// -- documentation: http://www.felix-colibri.com

(*$R+*)

unit u_c_genc_101_integer_stack;
  interface
    type c_integer_stack= Class
                            m_integer_array: Array of Integer;
                            m_top_of_stack: Integer;

                            constructor create_integer_stack(p_length: Integer);
                            procedure push(p_integer: Integer);
                            function f_pop: Integer;
                          end; // c_integer_stack

  implementation

    // -- c_integer_stack

    constructor c_integer_stack.create_integer_stack(p_length: Integer);
      begin
        Inherited Create;
        SetLength(m_integer_array, p_length);
      end; // create_integer_stack

    procedure c_integer_stack.push(p_integer: Integer);
      begin
        if m_top_of_stack< Length(m_integer_array)
          then begin
              m_integer_array[m_top_of_stack]:= p_integer;
              Inc(m_top_of_stack);
            end;
      end; // push

    function c_integer_stack.f_pop: Integer;
      begin
        if m_top_of_stack>= 0
          then begin
              Dec(m_top_of_stack);
              Result:= m_integer_array[m_top_of_stack];
            end
          else raise Exception.Create('empty') ;
      end; // f_pop

  end.
